#include <cstdlib>
#include "RtpManager.hpp"


RtpManager::RtpManager() {
    InetHostAddress localia("0.0.0.0");
    localaddr = localia;
}

RtpManager::~RtpManager() {}

bool RtpManager::createSession(std::string& xmname, std::string& xmpath,
		    unsigned short port) {
	rtpinfo_t sessioninfo;
	InetHostAddress inetaddr("0.0.0.0");
	// Ports must be even numbers
	assert(!(port % 2));
	sessioninfo.rtpport = port;
	sessioninfo.rtcpport = port + 1;
	sessioninfo.host = inetaddr;
	sessioninfo.sessionwrapper = new RtpWrapper(inetaddr,port,xmpath);
	sessioninfo.sessionwrapper->start();
	sessionmap[xmname] = sessioninfo;
	return true;
}

bool RtpManager::removeSession(std::string& xmname) {
  if (sessionmap.find(xmname) != sessionmap.end()){ 
    rtpinfo_t& sessioninfo = sessionmap[xmname];
    delete sessioninfo.sessionwrapper;
  }
  return true;
}

unsigned short RtpManager::getPort(std::string& xmname) {
	rtpinfo_t& sessioninfo = sessionmap[xmname];
	return sessioninfo.rtpport;
}

bool RtpManager::addDestination(std::string& xmname, std::string& identifier,
		    	std::string& destip,
		    	unsigned short port) {
	rtpinfo_t& sessioninfo = sessionmap[xmname];
	assert(sessioninfo.sessionwrapper->addDestination(identifier,destip,port));
	return true;
}

bool RtpManager::delDestination(std::string& xmname, std::string& identifier) {
  if (sessionmap.find(xmname) != sessionmap.end()) {
    rtpinfo_t& sessioninfo = sessionmap[xmname];
    sessioninfo.sessionwrapper->delDestination(identifier);
  }
  return true;
}
	
    
    
    
    
